\name{create.geotop.inpts.keyword}
\alias{create.geotop.inpts.keyword}
\title{Creates an 'geotop.inpts'  files the keyword and their values of a date.frame like the one returned by \code{\link{declared.geotop.inpts.keywords}}}
\usage{
  create.geotop.inpts.keyword(df,
    file = "geotop.inpts.copy",
    comment.lines = paste("!", c("", " insert optional comment for the keyword below", ""), sep = ""),
    header = c("", paste("!", file, "automatically generated by create.geotop.inpts.keyword ('geotobricks' CRAN R Paackage)"), "", ""),
    ...)
}
\arguments{
  \item{df}{data frame returend by
  \code{\link{declared.geotop.inpts.keywords}}}

  \item{file}{connetion or file name where to write 'df'}

  \item{comment.lines}{vector of strings to add as comments
  for each keyword. See the default values in the usage. If
  it is \code{NULL} the comment lines are omitted.}

  \item{header}{vector of strings to add as a header. See
  the default values in the usage. If it is \code{NULL} the
  header is omitted.}

  \item{...}{further arguments for
  \code{\link{writeLines}}}
}
\description{
  Creates an 'geotop.inpts' files the keyword and their
  values of a date.frame like the one returned by
  \code{\link{declared.geotop.inpts.keywords}}
}
\examples{
library(geotopbricks)

#Simulation working path
wpath <- 'http://meteogis.fmach.it/idroclima/panola13_run2xC_test3'
df <- declared.geotop.inpts.keywords(wpath=wpath)
create.geotop.inpts.keyword(df=df)
}
\seealso{
  \code{\link{writeLines}},\code{\link{declared.geotop.inpts.keywords}}
}

